//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LightSeaGreen
#property indicator_color2 LightSeaGreen
#property indicator_color3 LightSeaGreen
//---- indicator parameters
extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double BandsDeviations=2.0;
//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];

double AMA[];
double CloseData[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,LowerBuffer);
//----
   SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,BandsPeriod+BandsShift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int pos;
   double alpha, mt[], ut[], dt[], mt2[], ut2[], dt2[], but, blt, dtabs[];
   int    counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   
   pos = Bars-counted_bars-1;   
   while(pos>=0)
   {
      CloseData[pos] = Close[pos];
      pos--;
   }
   
   pos = Bars-counted_bars-1;
   while(pos>=0)
   {
      alpha=2/(BandsPeriod+1);
      mt[pos]=AMAOnArray(CloseData, alpha, pos+1);
      ut[pos]=AMAOnArray(mt, alpha, pos+1);
      dt[pos]=((2-alpha)*mt[pos]-ut[pos])/(1-alpha);
      dtabs[pos] = MathAbs(Close[pos]-dt[pos]);
      mt2[pos]=AMAOnArray(dtabs, alpha, pos+1);
      ut2[pos]=AMAOnArray(mt2,alpha, pos+1);
      dt2[pos]=((2-alpha)*mt2[pos]-ut2[pos])/(1-alpha);
      but=dt[pos]+BandsDeviations*dt2[pos];
      blt=dt[pos]-BandsDeviations*dt2[pos];

      UpperBuffer[pos]=but;
      LowerBuffer[pos]=blt;

      pos--;
   }
   return(0);
  }
//+------------------------------------------------------------------+
double AMAOnArray(double& data[], double sc, int shift)
{
  int period = MathRound((2/sc)-1);
  double Noise = 0;
  for (int i=0; i < period; i++)
  {
    if (shift+i+1 >= Bars) break;
    Noise += MathAbs(data[shift+i] - data[shift+i+1]);
  }
  
  double Signal = MathAbs(data[shift] - data[shift+period]);
  
  double ER = 1;
  if (Noise > 0) ER = Signal/Noise;
   	
  AMA[shift] = sc*data[shift] + (1 - sc)*AMA[shift+1];
        
  return (AMA[shift]);
}

